/*
Scrivere un programma per la gestione dei DVD  e dei prestiti.
I DVD sono caratterizzati dalle seguenti informazioni: Titolo film, codice DVD, anno, quantit, genere. 
I DVD sono inseriti in una tabella allocata dinamicamente avente 5 righe, una  per ogni genere di film. 
Ogni prestito  caratterizzato dalle seguenti informazioni: codice DVD, numero tessera, giorno prestito, genere di film. I prestiti vengono inseriti in un vettore di 5 liste, una per ogni genere di film.   
Le liste sono ordinate rispetto al numero di tessera.

Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1.Inserimento nella tabella di un nuovo DVD; 
2.Visualizzazione dei DVD di un certo genere;
3.Inserimento ordinato nel vettore di liste di un prestito;
4.Visualizzazione di una lista di prestiti ;
5.Eliminazione del primo prestito da una lista.

Liberare la memoria allocata dinamicamente
*/
#include<stdio.h>
#include<stdlib.h>

typedef struct {
        char titolo[30];
        long codice;
        int anno,quantita,genere;
        }dvd;
        
typedef struct {
        long codice;
        char data[11];
        int tessera,genere;
        }prestito;
        
struct atomo {
       prestito dato;
       struct atomo *next;
       };
       
void leggi_dvd(dvd *d);
void inserisci_dvd(dvd *T[5],int *N);
void visualizza_dvd(dvd *T[5],int *N);
void leggi_prestito(prestito *p);
void inserisci_prestito(struct atomo *VL[5]);
void visualizza_prestiti(struct atomo *VL[5]);
void elimina_prestito(struct atomo *VL[5]);

main()
{
      dvd *T[5];
      struct atomo *VL[5],*aux;
      int N[5],i,op;
      
      for(i=0;i<5;i++)
      {T[i]=NULL;
      N[i]=0;
      VL[i]=NULL;
      }
        
      do
      {
                 printf("\nScegli tra:\n");
                 printf("1) Inserimento di un DVD in tabella\n2) Visualizzazione dei DVD di un certo genere \n");
                 printf("3) Inserimento di un prestito in lista\n4) Visualizzazione di una lista prestiti\n");
                 printf("5) Eliminazione di un prestito da una lista\n0) fine\n");
                 scanf("%d",&op);
                 
      switch (op) {
             case 1:inserisci_dvd(T,N);
                    break;
             case 2:visualizza_dvd(T,N);
                    break;
             case 3:inserisci_prestito(VL);
                    break;
             case 4:visualizza_prestiti(VL);
                    break;
             case 5:elimina_prestito(VL);
                    break;
           default:;
           }
           }while(op);
           
    for(i=0;i<5;i++)
    free(T[i]);
    
    for(i=0;i<5;i++)
    while(VL[i]!=NULL)
    {
     aux=VL[i];
     VL[i]=aux->next;
     free(aux); 
    }
}  
      
void leggi_dvd(dvd *d)
{
     printf("Titolo DVD: ");
     scanf("%s",d->titolo);
     printf("Codice DVD: ");
     scanf("%ld",&d->codice);
     printf("Anno di produzione: ");
     scanf("%d",&d->anno);
     printf("Quantita': ");
     scanf("%d",&d->quantita);
     printf("Genere (0, 1, ... 4): ");
     scanf("%d",&d->genere);
     }
     
     
void inserisci_dvd(dvd *T[5],int *N)
{
     dvd d,*aux;
     int genere;
     
     leggi_dvd(&d);
     genere=d.genere;
     aux=realloc(T[genere],sizeof(dvd)*(N[genere]+1));
     if(aux==NULL)
     return;
     
     T[genere]=aux;
     T[genere][N[genere]]=d;
     N[genere]++;
}
     
     
     
void visualizza_dvd(dvd *T[5],int *N)
{
     int i,genere;
     
     printf("Genere: ");
     scanf("%d",&genere);
     for(i=0;i<N[genere];i++)
     {
      printf("\nTitolo DVD: %s",T[genere][i].titolo);
      printf("\nCodice DVD: %ld",T[genere][i].codice);
      printf("\nAnno di produzione: %d",T[genere][i].anno);
      printf("\nQuantita': %d\n",T[genere][i].quantita);
     }
}
     
     
     
void leggi_prestito(prestito *p)
{
     printf("Codice DVD: ");
     scanf("%ld",&p->codice);
     printf("Data: ");
     scanf("%s",p->data);
     printf("Numero tessera: ");
     scanf("%d",&p->tessera);
     printf("Genere (0, 1, ... 4): ");
     scanf("%d",&p->genere);
     }
     
void inserisci_prestito(struct atomo *VL[5])
{
     prestito p;
     struct atomo *l1,*l2,*aux;
     int genere;
     
     leggi_prestito(&p);
     genere=p.genere;
     aux=malloc(sizeof(struct atomo));
     if(aux==NULL)
     {
     printf("Memoria non allocata!\n");
     return;
     }
     aux->dato=p;
     
     if(VL[genere]==NULL || p.tessera<VL[genere]->dato.tessera)
     {
     aux->next=VL[genere];
     VL[genere]=aux;
     return;
     }
     
     l2=VL[genere];
     l1=l2->next;
     while(l1)
     if(p.tessera<l1->dato.tessera)
           break;
     else 
     {
          l2=l1;
          l1=l1->next;
          }
     aux->next=l1;
     l2->next=aux;
     }
     
     
     
     
void visualizza_prestiti(struct atomo *VL[5])
{
     struct atomo *l;
     int genere;
     printf("Genere da visualizzare (0, 1, ... 4): ");
     scanf("%d",&genere); 
     l=VL[genere];
     while(l)
     {
      printf("\nCodice DVD: %ld",l->dato.codice);
      printf("\nData:  %s",l->dato.data);
      printf("\nNumero tessera: %d\n",l->dato.tessera);
      l=l->next;
     }
}
             
void elimina_prestito(struct atomo *VL[5])
{
     /* Questa funzione elimina l'elemento in testa alla lista */
     
     struct atomo *aux;
     int genere;
     
     printf("Genere (0, 1, ... 4): ");
     scanf("%d",&genere);
     
     if(VL[genere]==NULL)
     {
      printf("Lista vuota!\n");
      return;
      }
    aux=VL[genere];
    VL[genere]=aux->next;
    free(aux);
    
}
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
      
